/*
 * Copyright 2010 Semafor Informatik & Energie AG, Basel, Switzerland
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.

 */
package ch.semafor.gendas.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

 @Entity
 @Table(name="property_types")
public class PropertyType implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=GenerationType.AUTO)	
  private Long id; // NOPMD by wim on 9/20/10 2:21 PM

  @Column(unique=true,nullable=false)
  private String name;
//		@ManyToOne
//		@JoinColumn(name="elementtype_id", nullable=false)
//		ElementType elementType;
//		
//		public ElementType getElementType() {
//			return elementType;
//		}
//		public void setElementType(ElementType elementType) {
//			this.elementType = elementType;
//		}
  
  public PropertyType(){
    super();
  }
  public PropertyType(final String type){
    super();
    this.name=type;
  }
  
  // getter and setter of Id
  public Long getId() {
    return id;
  }
  public void setId(Long id) { // NOPMD by wim on 9/20/10 2:21 PM
    this.id = id;
  }
  
  // getter and setter of Name
  public String getName() {
    return name;
  }
  public void setName(final String name) {
    this.name = name;
  }
		
  public String toString() {
    ToStringBuilder sb = new ToStringBuilder(this,ToStringStyle.SHORT_PREFIX_STYLE); // NOPMD by wim on 9/20/10 2:21 PM
    sb.append("id", this.id);
    sb.append( "serialVersionUID", serialVersionUID );
    sb.append("name", this.name);
    return sb.toString();
  }

  /**
   * {@inheritDoc}
   */
  public boolean equals(Object o) { // NOPMD by wim on 9/20/10 2:21 PM
    if (this == o) {
      return true; // NOPMD by wim on 9/20/10 2:21 PM
    }
    if (!(o instanceof PropertyType)) {
      return false; // NOPMD by wim on 9/20/10 2:21 PM
    }
    final PropertyType t = (PropertyType) o; // NOPMD by wim on 9/20/10 2:21 PM
    
    if( name != null){
      return name.equals(t.getName()); // NOPMD by wim on 9/20/10 2:20 PM
    }
    return !(t.getName() != null);
  }

  /**
   * {@inheritDoc}
   */
  public int hashCode() {
    return (name != null ? name.hashCode() : 0); // NOPMD by wim on 9/20/10 2:21 PM
  }
}
